searchNodes=[{"doc":"Provides functions to make HTTP requests to a Matrix homeserver using the MatrixSDK.Client.Request and MatrixSDK.HTTPClient modules.3PID API flowsSee this gist for more details.Flow 1—adding a 3PID to HS account during registration:registration_email_token/5 or registration_msisdn_token/6register_user/4Flow 2—adding a 3PID to HS account after registration:account_email_token/5 or account_msisdn_token/6account_add_3pid/5Flow 3—changing the bind status of a 3PID: this is currently unsupported but will be available once the identity server endpoints are wrapped.Flow 4—reset password via email:password_email_token/5change_password/4","ref":"MatrixSDK.Client.html","title":"MatrixSDK.Client","type":"module"},{"doc":"Gets a list of the third party identifiers the homeserver has associated with the user's account.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.ExamplesMatrixSDK.Client.account_3pids(&quot;https://matrix.org&quot;, &quot;token&quot;)","ref":"MatrixSDK.Client.html#account_3pids/2","title":"MatrixSDK.Client.account_3pids/2","type":"function"},{"doc":"Adds contact information to the user's account.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.client_secret: the client secret used in the session with the homeserver.sid: the session ID give by the homeserver. Optional:auth: a map containing autentication data as defined by MatrixSDK.Client.Auth.For more info see 3PID API flows section above.ExamplesMatrixSDK.Client.account_add_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;sid&quot;)","ref":"MatrixSDK.Client.html#account_add_3pid/5","title":"MatrixSDK.Client.account_add_3pid/5","type":"function"},{"doc":"Binds contact information to the user's account through the specified identity server.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.client_secret: the client secret used in the session with the identity server.id_server: the identity server to use.id_access_token: an access token previously registered with the identity server.sid: the session ID given by the identity server.For more info see 3PID API flows section above.ExamplesMatrixSDK.Client.account_bind_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;example.org&quot;, &quot;abc123&quot;, &quot;sid&quot;)","ref":"MatrixSDK.Client.html#account_bind_3pid/6","title":"MatrixSDK.Client.account_bind_3pid/6","type":"function"},{"doc":"Deletes contact information from the user's account.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.medium: the medium of the third party identifier being removed. One of: &quot;email&quot; or &quot;msisdn&quot;.address: the third party address being removed.Optional: id_server: the identity server to unbind from.ExamplesMatrixSDK.Client.account_delete_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;email&quot;, &quot;example@example.org&quot;)With id_server option:MatrixSDK.Client.account_delete_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;email&quot;, &quot;example@example.org&quot;, %{id_server: &quot;id.example.org&quot;)","ref":"MatrixSDK.Client.html#account_delete_3pid/5","title":"MatrixSDK.Client.account_delete_3pid/5","type":"function"},{"doc":"Requests a validation token when adding an email to a user's account.For more info see 3PID API flows section above. ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.email: the email address.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL. ExamplesMatrixSDK.Client.account_email_token(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;example@example.org&quot;, 1)With optional parameter:opt = %{next_link: &quot;test-site.url&quot;} MatrixSDK.Client.account_email_token(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;example@example.org&quot;, 1, opts)","ref":"MatrixSDK.Client.html#account_email_token/6","title":"MatrixSDK.Client.account_email_token/6","type":"function"},{"doc":"Requests a validation token when adding a phone number to a user's account.For more info see 3PID API flows section above.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.country: the two-letter uppercase ISO-3166-1 alpha-2 country code.phone: the phone number.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL.ExamplesMatrixSDK.Client.account_msisdn_token(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1)With optional paramter:opt = %{next_link: &quot;test-site.url&quot;} MatrixSDK.Client.account_msisdn_token(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1, opt)","ref":"MatrixSDK.Client.html#account_msisdn_token/7","title":"MatrixSDK.Client.account_msisdn_token/7","type":"function"},{"doc":"Unbinds contact information from the user's account without deleting it from the homeserver.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.medium: the medium of the third party identifier being removed. One of: &quot;email&quot; or &quot;msisdn&quot;.address: the third party address being removed. Optional:id_server: the identity server to unbind from.ExamplesMatrixSDK.Client.account_unbind_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;email&quot;, &quot;example@example.org&quot;)With id_server option:MatrixSDK.Client.account_unbind_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;email&quot;, &quot;example@example.org&quot;, %{id_server: &quot;id.example.org&quot;})","ref":"MatrixSDK.Client.html#account_unbind_3pid/5","title":"MatrixSDK.Client.account_unbind_3pid/5","type":"function"},{"doc":"Retrieves the avatar url for a user.ArgsRequired: base_url: the base URL for the homeserver. user_id: the user ID.ExamplesMatrixSDK.Client.avatar_url(&quot;https://matrix.org&quot;, &quot;@user:matrix.org&quot;)","ref":"MatrixSDK.Client.html#avatar_url/2","title":"MatrixSDK.Client.avatar_url/2","type":"function"},{"doc":"Changes the password for an account on the homeserver. This request will need to be authenticated with m.login.email.identity or m.login.msisdn.identity. For more info see 3PID API flows section above. ArgsRequired:base_url: the base URL for the homeserver. new_password: the desired password for the account.auth: a map containing autentication data as defined by MatrixSDK.Client.Auth.Optional: logout_devices: true or false, whether the user's other access tokens, and their associated devices, should be revoked if the request succeeds.Examplesauth = MatrixSDK.Client.Auth.login_email_identity(&quot;sid&quot;, &quot;client_secret&quot;) MatrixSDK.Client.Request.change_password(&quot;https://matrix.org&quot;, &quot;new_password&quot;, auth)","ref":"MatrixSDK.Client.html#change_password/4","title":"MatrixSDK.Client.change_password/4","type":"function"},{"doc":"Creates a new room. ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.Optional: visibility: controls the presence of the room on the room list. One of: &quot;public&quot; or &quot;private&quot;.room_alias_name: the desired room alias local part. name: if this is included, an m.room.name event will be sent into the room to indicate the name of the room. topic: if this is included, an m.room.topic event will be sent into the room to indicate the topic for the room.invite: a list of user IDs to invite to the room.invite_3pid: a list of objects representing third party IDs to invite into the room.room_version: the room version to set for the room.creation_content: extra keys, such as m.federate, to be added to the content of the m.room.create event.initial_state: a list of state events to set in the new room.preset: convenience parameter for setting various default state events based on a preset.is_direct: boolean flag. power_level_content_override: the power level content to override in the default power level event. ExamplesMatrixSDK.Client.create_room(&quot;https://matrix.org&quot;, &quot;token&quot;)With options:opts = %{ visibility: &quot;public&quot;, room_alias_name: &quot;chocolate&quot;, topic: &quot;Some cool stuff about chocolate.&quot; } MatrixSDK.Client.create_room(&quot;https://matrix.org&quot;, &quot;token&quot;, opts)","ref":"MatrixSDK.Client.html#create_room/3","title":"MatrixSDK.Client.create_room/3","type":"function"},{"doc":"Deactivates a user's account. ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.Optional: auth: a map containing autentication data as defined by MatrixSDK.Client.Auth.ExamplesMatrixSDK.Client.deactivate_account(&quot;https://matrix.org&quot;, &quot;token&quot;)","ref":"MatrixSDK.Client.html#deactivate_account/3","title":"MatrixSDK.Client.deactivate_account/3","type":"function"},{"doc":"Retrieves the display name for a user.ArgsRequired: base_url: the base URL for the homeserver. user_id: the user ID.ExamplesMatrixSDK.Client.display_name(&quot;https://matrix.org&quot;, &quot;@user:matrix.org&quot;)","ref":"MatrixSDK.Client.html#display_name/2","title":"MatrixSDK.Client.display_name/2","type":"function"},{"doc":"Lets a user forget a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.ExampleMatrixSDK.Client.forget_room(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;)","ref":"MatrixSDK.Client.html#forget_room/3","title":"MatrixSDK.Client.forget_room/3","type":"function"},{"doc":"Lets a user join a room.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id_or_alias: the room ID or room alias.Optional: third_party_signed: a signature of an m.third_party_invite token to prove that this user owns a third party identity which has been invited to the room.ExampleMatrixSDK.Client.join_room(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;)","ref":"MatrixSDK.Client.html#join_room/4","title":"MatrixSDK.Client.join_room/4","type":"function"},{"doc":"Gets a list of the user's current rooms.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.ExampleMatrixSDK.Client.joined_rooms(&quot;https://matrix.org&quot;, &quot;token&quot;)","ref":"MatrixSDK.Client.html#joined_rooms/2","title":"MatrixSDK.Client.joined_rooms/2","type":"function"},{"doc":"Lets a user leave a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.ExampleMatrixSDK.Client.leave_room(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;)","ref":"MatrixSDK.Client.html#leave_room/3","title":"MatrixSDK.Client.leave_room/3","type":"function"},{"doc":"Gets the homeserver's supported login types to authenticate users. ArgsRequired: base_url: the base URL for the homeserver.ExamplesMatrixSDK.Client.login(&quot;https://matrix.org&quot;)","ref":"MatrixSDK.Client.html#login/1","title":"MatrixSDK.Client.login/1","type":"function"},{"doc":"Authenticates the user, and issues an access token they can use to authorize themself in subsequent requests.ArgsRequired:base_url: the base URL for the homeserver. auth: a map containing autentication data as defined by MatrixSDK.Client.Auth.Optional:device_id: ID of the client device. If this does not correspond to a known client device, a new device will be created. The server will auto-generate a device_id if this is not specified.initial_device_display_name: a display name to assign to the newly-created device.ExamplesToken authentication:auth = MatrixSDK.Client.Auth.login_token(&quot;token&quot;) MatrixSDK.Client.login(&quot;https://matrix.org&quot;, auth)User and password authentication with optional parameters:auth = MatrixSDK.Client.Auth.login_user(&quot;maurice_moss&quot;, &quot;password&quot;) opts = %{device_id: &quot;id&quot;, initial_device_display_name: &quot;THE INTERNET&quot;} MatrixSDK.Client.login(&quot;https://matrix.org&quot;, auth, opts)","ref":"MatrixSDK.Client.html#login/3","title":"MatrixSDK.Client.login/3","type":"function"},{"doc":"Invalidates an existing access token, so that it can no longer be used for authorization.ArgsRequired:base_url: the base URL for the homeserver.token: access token, typically obtained via the login or registration processes.ExamplesMatrixSDK.Client.logout(&quot;https://matrix.org&quot;, &quot;token&quot;)","ref":"MatrixSDK.Client.html#logout/2","title":"MatrixSDK.Client.logout/2","type":"function"},{"doc":"Invalidates all existing access tokens, so that they can no longer be used for authorization.ArgsRequired:base_url: the base URL for the homeserver.token: access token, typically obtained via the login or registration processes.ExamplesMatrixSDK.Client.logout_all(&quot;https://matrix.org&quot;, &quot;token&quot;)","ref":"MatrixSDK.Client.html#logout_all/2","title":"MatrixSDK.Client.logout_all/2","type":"function"},{"doc":"Request validation tokens when authenticating for change_password/4. For more info see 3PID API flows section above. ArgsRequired:base_url: the base URL for the homeserver. client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.email: the email address.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL.ExamplesMatrixSDK.Client.password_email_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;maurice@moss.yay&quot;, 1)","ref":"MatrixSDK.Client.html#password_email_token/5","title":"MatrixSDK.Client.password_email_token/5","type":"function"},{"doc":"Request validation tokens when authenticating for change_password/4.For more info see 3PID API flows section above. ArgsRequired:base_url: the base URL for the homeserver. client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.country: the two-letter uppercase ISO-3166-1 alpha-2 country code.phone: the phone number.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL. ExamplesMatrixSDK.Client.password_msisdn_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1)","ref":"MatrixSDK.Client.html#password_msisdn_token/6","title":"MatrixSDK.Client.password_msisdn_token/6","type":"function"},{"doc":"Lists the public rooms on the server with basic filtering.ArgsRequired: base_url: the base URL for the homeserver. Optional: limit: limit the number of results returned.since: a pagination token from a previous request, allowing clients to get the next (or previous) batch of rooms.server: the server to fetch the public room lists from.ExamplesMatrixSDK.Client.public_rooms(&quot;https://matrix.org&quot;)With optional parameters: MatrixSDK.Client.public_rooms(&quot;https://matrix.org&quot;, %{limit: 10})","ref":"MatrixSDK.Client.html#public_rooms/2","title":"MatrixSDK.Client.public_rooms/2","type":"function"},{"doc":"Lists the public rooms on the server with more advanced filtering options. ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.filters: limit: limit the number of results returned.since: a pagination token from a previous request, allowing clients to get the next (or previous) batch of rooms.filter: a string to search for in the room metadata, e.g. name, topic, canonical alias, etc...include_all_networks: boolean, whether or not to include all known networks/protocols from application services on the homeserver. third_party_instance_id: the specific third party network/protocol to request from the homeserver. Can only be used if include_all_networks is false.Optional: server: the server to fetch the public room lists from.ExamplesMatrixSDK.Client.public_rooms(&quot;https://matrix.org&quot;, &quot;token&quot;, %{limit: 10})With optional parameter:MatrixSDK.Client.public_rooms(&quot;https://matrix.org&quot;, &quot;token&quot;, %{limit: 10}, &quot;server&quot;)","ref":"MatrixSDK.Client.html#public_rooms/4","title":"MatrixSDK.Client.public_rooms/4","type":"function"},{"doc":"Redacts a room event with a reason.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID. event_id: the event ID.transaction_id: the transaction ID for this event. Clients should generate a unique ID; it will be used by the server to ensure idempotency of requests.Optional: reason: the reason for the event being redacted.ExamplesMatrixSDK.Client.redact_room_event(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom@matrix.org&quot;, &quot;event_id&quot;, &quot;transaction_id&quot;)With reason option:opt = %{reason: &quot;Indecent material&quot;} MatrixSDK.Client.redact_room_event(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom@matrix.org&quot;, &quot;event_id&quot;, &quot;transaction_id&quot;, opt)","ref":"MatrixSDK.Client.html#redact_room_event/6","title":"MatrixSDK.Client.redact_room_event/6","type":"function"},{"doc":"Registers a guest account on the homeserver and returns an access token which can be used to authenticate subsequent requests. ArgsRequired:base_url: the base URL for the homeserver. Optional: initial_device_display_name: a display name to assign to the newly-created device.ExamplesMatrixSDK.Client.register_guest(&quot;https://matrix.org&quot;)Specifiying a display name for the device: opts = %{initial_device_display_name: &quot;THE INTERNET&quot;} MatrixSDK.Client.register_guest(&quot;https://matrix.org&quot;, opts)","ref":"MatrixSDK.Client.html#register_guest/2","title":"MatrixSDK.Client.register_guest/2","type":"function"},{"doc":"Registers a user account on the homeserver.ArgsRequired:base_url: the base URL for the homeserver. password: the desired password for the account.auth: a map containing autentication data as defined by MatrixSDK.Client.Auth. This is used to authenticate the registration request, not to define how a user will be authenticated. Optional: username: the basis for the localpart of the desired Matrix ID. If omitted, the homeserver will generate a Matrix ID local part.device_id: ID of the client device. If this does not correspond to a known client device, a new device will be created. The server will auto-generate a device_id if this is not specified.initial_device_display_name: a display name to assign to the newly-created device.inhibit_login: if true, an access_token and device_id will not be returned from this call, therefore preventing an automatic login.ExamplesMatrixSDK.Client.Request.register_user(&quot;https://matrix.org&quot;, &quot;password&quot;, auth)With optional parameters: auth = MatrixSDK.Client.Auth.login_dummy() opts = %{ username: &quot;maurice_moss&quot;, device_id: &quot;id&quot;, initial_device_display_name: &quot;THE INTERNET&quot;, inhibit_login: true } MatrixSDK.Client.Request.register_user(&quot;https://matrix.org&quot;, &quot;password&quot;, auth, opts)","ref":"MatrixSDK.Client.html#register_user/4","title":"MatrixSDK.Client.register_user/4","type":"function"},{"doc":"Checks the given email address is not already associated with an account on the homeserver. This should be used to get a token to register an email as part of the initial user registration.For more info see 3PID API flows section above.ArgsRequired:base_url: the base URL for the homeserver. client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.email: the email address.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL. Examples MatrixSDK.Client.registration_email_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;maurice@moss.yay&quot;, 1)","ref":"MatrixSDK.Client.html#registration_email_token/5","title":"MatrixSDK.Client.registration_email_token/5","type":"function"},{"doc":"Checks the given phone number is not already associated with an account on the homeserver. This should be used to get a token to register a phone number as part of the initial user registration.For more info see 3PID API flows section above.ArgsRequired:base_url: the base URL for the homeserver. client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.country: the two-letter uppercase ISO-3166-1 alpha-2 country code.phone: the phone number.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL.Examples MatrixSDK.Client.registration_msisdn_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1)","ref":"MatrixSDK.Client.html#registration_msisdn_token/6","title":"MatrixSDK.Client.registration_msisdn_token/6","type":"function"},{"doc":"Bans a user from a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.user_id: the user ID to ban from the room.Optional: reason: the reason the user has been banned.ExamplesMatrixSDK.Client.room_ban(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;)With option: MatrixSDK.Client.room_ban(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;, %{reason: &quot;Ate all the chocolate&quot;})","ref":"MatrixSDK.Client.html#room_ban/5","title":"MatrixSDK.Client.room_ban/5","type":"function"},{"doc":"Gets a single event based on room_id and event_id.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the ID of the room the event is in. event_id: the event ID.ExampleMatrixSDK.Client.room_event(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;$someevent&quot;)","ref":"MatrixSDK.Client.html#room_event/4","title":"MatrixSDK.Client.room_event/4","type":"function"},{"doc":"Invites a user to participate in a particular room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.user_id: the user ID to invite to the room.ExampleMatrixSDK.Client.room_invite(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;)","ref":"MatrixSDK.Client.html#room_invite/4","title":"MatrixSDK.Client.room_invite/4","type":"function"},{"doc":"Gets a map of MXIDs to member info objects for members of the room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.ExampleMatrixSDK.Client.room_joined_members(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;)","ref":"MatrixSDK.Client.html#room_joined_members/3","title":"MatrixSDK.Client.room_joined_members/3","type":"function"},{"doc":"Kicks a user from a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.user_id: the user ID to kick from the room.Optional: reason: the reason the user has been kicked.ExamplesMatrixSDK.Client.room_kick(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;)With option: MatrixSDK.Client.room_kick(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;, %{reason: &quot;Ate all the chocolate&quot;})","ref":"MatrixSDK.Client.html#room_kick/5","title":"MatrixSDK.Client.room_kick/5","type":"function"},{"doc":"Gets the list of members for this room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.Optional: at: the point in time (pagination token) to return members for in the room.membership: the kind of membership to filter for. Defaults to no filtering if unspecified.not_membership: the kind of membership to exclude from the results. Defaults to no filtering if unspecified. One of: &quot;join&quot;, &quot;invite&quot;, &quot;leave&quot;, &quot;ban&quot;.ExamplesMatrixSDK.Client.room_members(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;)With optional parameters:opts = %{ at: &quot;t123456789&quot;, membership: &quot;join&quot;, not_membership: &quot;invite&quot; } MatrixSDK.Client.room_members(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, opts)","ref":"MatrixSDK.Client.html#room_members/4","title":"MatrixSDK.Client.room_members/4","type":"function"},{"doc":"Gets message and state events for a room. It uses pagination parameters to paginate history in the room.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID. from: the pagination token to start returning events from.dir: the direction to return events from. One of: &quot;b&quot; or &quot;f&quot;.Optional: to: the pagination token to stop returning events at.limit: the maximum number of events to return. filter: a filter to apply to the returned events. ExamplesMatrixSDK.Client.room_messages(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;t123456789&quot;, &quot;f&quot;)With optional parameters:opts = %{ to: &quot;t123456789&quot;, limit: 10, filter: &quot;filter&quot; } MatrixSDK.Client.room_messages(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;t123456789&quot;, &quot;f&quot;, opts)","ref":"MatrixSDK.Client.html#room_messages/6","title":"MatrixSDK.Client.room_messages/6","type":"function"},{"doc":"Gets the state events for the current state of a room.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room the events are in. ExampleMatrixSDK.Client.room_state(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;)","ref":"MatrixSDK.Client.html#room_state/3","title":"MatrixSDK.Client.room_state/3","type":"function"},{"doc":"Looks up the contents of a state event in a room.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room the state event is in.event_type: the type of the state event.state_key: the key of the state to look up. Often an empty string.ExampleMatrixSDK.Client.room_state_event(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;m.room.member&quot;, &quot;@user:matrix.org&quot;)","ref":"MatrixSDK.Client.html#room_state_event/5","title":"MatrixSDK.Client.room_state_event/5","type":"function"},{"doc":"Unbans a user from a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.user_id: the user ID to unban from the room.ExamplesMatrixSDK.Client.room_unban(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;)","ref":"MatrixSDK.Client.html#room_unban/4","title":"MatrixSDK.Client.room_unban/4","type":"function"},{"doc":"Gets the visibility of a given room on the server's public room directory.ArgsRequired: base_url: the base URL for the homeserver. room_id: the room ID.ExampleMatrixSDK.Client.room_visibility(&quot;https://matrix.org&quot;, &quot;!someroom:matrix.org&quot;)","ref":"MatrixSDK.Client.html#room_visibility/2","title":"MatrixSDK.Client.room_visibility/2","type":"function"},{"doc":"Sets the visibility of a given room in the server's public room directory.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.visibility: the new visibility setting for the room. One of: &quot;private&quot; or &quot;public&quot;.ExampleMatrixSDK.Client.room_visibility(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;private&quot;)","ref":"MatrixSDK.Client.html#room_visibility/4","title":"MatrixSDK.Client.room_visibility/4","type":"function"},{"doc":"Sends a room event to a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_event: a state event as defined in MatrixSDK.Client.RoomEvent. Exampleroom_event = MatrixSDK.Client.RoomEvent.message(&quot;!someroom:matrix.org&quot;, :text, &quot;Fire! Fire! Fire!&quot;, &quot;transaction_id&quot;) MatrixSDK.Client.Request.send_room_event(&quot;https://matrix.org&quot;, &quot;token&quot;, room_event)","ref":"MatrixSDK.Client.html#send_room_event/3","title":"MatrixSDK.Client.send_room_event/3","type":"function"},{"doc":"Sends a state event to a room. ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.state_event: a state event as defined in MatrixSDK.Client.StateEvent.Examplestate_event = MatrixSDK.Client.StateEvent.join_rules(&quot;!someroom:matrix.org&quot;, &quot;private&quot;) MatrixSDK.Client.Request.send_state_event(&quot;https://matrix.org&quot;, &quot;token&quot;, state_event)","ref":"MatrixSDK.Client.html#send_state_event/3","title":"MatrixSDK.Client.send_state_event/3","type":"function"},{"doc":"Gets information about the server's supported feature set and other relevant capabilities.ArgsRequired:base_url: the base URL for the homeserver.token: access token, typically obtained via the login or registration processes.ExamplesMatrixSDK.Client.server_capabilities(&quot;https://matrix.org&quot;, &quot;token&quot;)","ref":"MatrixSDK.Client.html#server_capabilities/2","title":"MatrixSDK.Client.server_capabilities/2","type":"function"},{"doc":"Gets discovery information about the domain. ArgsRequired:base_url: the base URL for the homeserver. ExamplesMatrixSDK.Client.server_discovery(&quot;https://matrix.org&quot;)","ref":"MatrixSDK.Client.html#server_discovery/1","title":"MatrixSDK.Client.server_discovery/1","type":"function"},{"doc":"Sets the avatar url for a user.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.user_id: the user ID.avatar_url: the new avatar URL for this user.ExamplesMatrixSDK.Client.set_avatar_url(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;@user:matrix.org&quot;, &quot;mxc://matrix.org/wefh34uihSDRGhw34&quot;)","ref":"MatrixSDK.Client.html#set_avatar_url/4","title":"MatrixSDK.Client.set_avatar_url/4","type":"function"},{"doc":"Sets the display name for a user.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.user_id: the user ID.display_name: new display name.ExamplesMatrixSDK.Client.set_display_name(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;@user:matrix.org&quot;, &quot;mickey&quot;)","ref":"MatrixSDK.Client.html#set_display_name/4","title":"MatrixSDK.Client.set_display_name/4","type":"function"},{"doc":"Gets the versions of the Matrix specification supported by the server. ArgsRequired:base_url: the base URL for the homeserver. ExamplesMatrixSDK.Client.spec_versions(&quot;https://matrix.org&quot;)","ref":"MatrixSDK.Client.html#spec_versions/1","title":"MatrixSDK.Client.spec_versions/1","type":"function"},{"doc":"Synchronises the client's state with the latest state on the server.ArgsRequired:base_url: the base URL for the homeserver. token: the authentication token returned from user login. Optional:filter: the ID of a filter created using the filter API or a filter JSON object encoded as a string.since: a point in time to continue a sync from (usuall the next_batch value from last sync).full_state: controls whether to include the full state for all rooms the user is a member of.set_presence: controls whether the client is automatically marked as online by polling this API.timeout: the maximum time to wait, in milliseconds, before returning this request.ExamplesMatrixSDK.Client.sync(&quot;https://matrix.org&quot;, &quot;token&quot;)With optional parameters:opts = %{ since: &quot;s123456789&quot;, filter: &quot;filter&quot;, full_state: true, set_presence: &quot;online&quot;, timeout: 1000 } MatrixSDK.Client.sync(&quot;https://matrix.org&quot;, &quot;token&quot;, opts)","ref":"MatrixSDK.Client.html#sync/3","title":"MatrixSDK.Client.sync/3","type":"function"},{"doc":"Searches for users based on search term.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.search_term: the term to search for.Optional: limit: limit the number of returned results.language: sets the language header for the request.ExamplesMatrixSDK.Client.user_directory_search(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;mickey&quot;)With options:MatrixSDK.Client.user_directory_search(&quot;https://matrix.org&quot;, &quot;token&quot;, %{limit: 10, language: &quot;en-US&quot;})","ref":"MatrixSDK.Client.html#user_directory_search/4","title":"MatrixSDK.Client.user_directory_search/4","type":"function"},{"doc":"Retrieves the user profile for a user.ArgsRequired: base_url: the base URL for the homeserver. user_id: the user ID.ExamplesMatrixSDK.Client.user_profile(&quot;https://matrix.org&quot;, &quot;@user:matrix.org&quot;)","ref":"MatrixSDK.Client.html#user_profile/2","title":"MatrixSDK.Client.user_profile/2","type":"function"},{"doc":"Checks if a username is available and valid for the server.ArgsRequired:base_url: the base URL for the homeserver. username: the basis for the localpart of the desired Matrix ID.Examples MatrixSDK.Client.username_availability(&quot;https://matrix.org&quot;, &quot;maurice_moss&quot;)","ref":"MatrixSDK.Client.html#username_availability/2","title":"MatrixSDK.Client.username_availability/2","type":"function"},{"doc":"Gets information about the owner of a given access token.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.ExamplesMatrixSDK.Client.whoami(&quot;https://matrix.org&quot;, &quot;token&quot;)","ref":"MatrixSDK.Client.html#whoami/2","title":"MatrixSDK.Client.whoami/2","type":"function"},{"doc":"Provides functions to makes HTTP requests using Tesla.","ref":"MatrixSDK.HTTPClient.html","title":"MatrixSDK.HTTPClient","type":"behaviour"},{"doc":"","ref":"MatrixSDK.HTTPClient.html#client/2","title":"MatrixSDK.HTTPClient.client/2","type":"function"},{"doc":"","ref":"MatrixSDK.HTTPClient.html#do_request/1","title":"MatrixSDK.HTTPClient.do_request/1","type":"function"},{"doc":"","ref":"MatrixSDK.HTTPClient.html#c:do_request/1","title":"MatrixSDK.HTTPClient.do_request/1","type":"callback"},{"doc":"","ref":"MatrixSDK.HTTPClient.html#t:option/0","title":"MatrixSDK.HTTPClient.option/0","type":"type"},{"doc":"","ref":"MatrixSDK.HTTPClient.html#t:result/0","title":"MatrixSDK.HTTPClient.result/0","type":"type"},{"doc":"Convenience functions for building authentication types.Note: an identifier is only used when doing a password login.","ref":"MatrixSDK.Client.Auth.html","title":"MatrixSDK.Client.Auth","type":"module"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#login_3pid/3","title":"MatrixSDK.Client.Auth.login_3pid/3","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#login_dummy/0","title":"MatrixSDK.Client.Auth.login_dummy/0","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#login_email_identity/2","title":"MatrixSDK.Client.Auth.login_email_identity/2","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#login_msisdn/2","title":"MatrixSDK.Client.Auth.login_msisdn/2","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#login_phone/3","title":"MatrixSDK.Client.Auth.login_phone/3","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#login_recaptcha/1","title":"MatrixSDK.Client.Auth.login_recaptcha/1","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#login_token/1","title":"MatrixSDK.Client.Auth.login_token/1","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#login_user/2","title":"MatrixSDK.Client.Auth.login_user/2","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#put_session/2","title":"MatrixSDK.Client.Auth.put_session/2","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:dummy/0","title":"MatrixSDK.Client.Auth.dummy/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:id/0","title":"MatrixSDK.Client.Auth.id/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:id_phone/0","title":"MatrixSDK.Client.Auth.id_phone/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:id_thirdparty/0","title":"MatrixSDK.Client.Auth.id_thirdparty/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:id_user/0","title":"MatrixSDK.Client.Auth.id_user/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:password/0","title":"MatrixSDK.Client.Auth.password/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:recaptcha/0","title":"MatrixSDK.Client.Auth.recaptcha/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:t/0","title":"MatrixSDK.Client.Auth.t/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:thirdparty/0","title":"MatrixSDK.Client.Auth.thirdparty/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Auth.html#t:token/0","title":"MatrixSDK.Client.Auth.token/0","type":"type"},{"doc":"Provides functions which return a struct containing the data necessary for each HTTP request.","ref":"MatrixSDK.Client.Request.html","title":"MatrixSDK.Client.Request","type":"module"},{"doc":"Returns a %Request{} struct used to get a list of the third party identifiers the homeserver has associated with the user's account.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.Examplesiex&gt; MatrixSDK.Client.Request.account_3pids(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/account/3pid&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#account_3pids/2","title":"MatrixSDK.Client.Request.account_3pids/2","type":"function"},{"doc":"Returns a %Request{} struct used to add contact information to the user's account.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.client_secret: the client secret used in the session with the homeserver.sid: the session ID give by the homeserver. Optional:auth: a map containing autentication data as defined by MatrixSDK.Client.Auth.For more info see 3PID API flows section on the MatrixSDK.Client module.Examplesiex&gt; MatrixSDK.Client.Request.account_add_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;sid&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;client_secret&quot;, sid: &quot;sid&quot; }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/add&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#account_add_3pid/5","title":"MatrixSDK.Client.Request.account_add_3pid/5","type":"function"},{"doc":"Returns a %Request{} struct used to bind contact information to the user's account through the specified identity server.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.client_secret: the client secret used in the session with the identity server.id_server: the identity server to use.id_access_token: an access token previously registered with the identity server.sid: the session ID given by the identity server.For more info see 3PID API flows section on the MatrixSDK.Client module.Examplesiex&gt; MatrixSDK.Client.Request.account_bind_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;example.org&quot;, &quot;abc123&quot;, &quot;sid&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;client_secret&quot;, sid: &quot;sid&quot;, id_server: &quot;example.org&quot;, id_access_token: &quot;abc123&quot; }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/bind&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#account_bind_3pid/6","title":"MatrixSDK.Client.Request.account_bind_3pid/6","type":"function"},{"doc":"Returns a %Request{} struct used to delete contact information from the user's account.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.medium: the medium of the third party identifier being removed. One of: &quot;email&quot; or &quot;msisdn&quot;.address: the third party address being removed.Optional: id_server: the identity server to unbind from.Examplesiex&gt; MatrixSDK.Client.Request.account_delete_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;email&quot;, &quot;example@example.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ medium: &quot;email&quot;, address: &quot;example@example.org&quot; }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/delete&quot;, query_params: [] }With optional id_server parameter:iex&gt; MatrixSDK.Client.Request.account_delete_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;email&quot;, &quot;example@example.org&quot;, %{id_server: &quot;example.org&quot;}) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ medium: &quot;email&quot;, address: &quot;example@example.org&quot;, id_server: &quot;example.org&quot; }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/delete&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#account_delete_3pid/5","title":"MatrixSDK.Client.Request.account_delete_3pid/5","type":"function"},{"doc":"Returns a %Request{} struct used to request a validation token when adding an email to a user's account.For more info see 3PID API flows section on the MatrixSDK.Client module. ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.email: the email address.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL. Examplesiex&gt; MatrixSDK.Client.Request.account_email_token(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;example@example.org&quot;, 1) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;client_secret&quot;, email: &quot;example@example.org&quot;, send_attempt: 1 }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/email/requestToken&quot;, query_params: [] }With optional parameter:iex&gt; opt = %{next_link: &quot;test-site.url&quot;} iex&gt; MatrixSDK.Client.Request.account_email_token(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;example@example.org&quot;, 1, opt) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;client_secret&quot;, email: &quot;example@example.org&quot;, next_link: &quot;test-site.url&quot;, send_attempt: 1 }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/email/requestToken&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#account_email_token/6","title":"MatrixSDK.Client.Request.account_email_token/6","type":"function"},{"doc":"Returns a %Request{} struct used to request a validation token when adding a phone number to a user's account.For more info see 3PID API flows section on the MatrixSDK.Client module. ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.country: the two-letter uppercase ISO-3166-1 alpha-2 country code.phone: the phone number.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL.Examplesiex&gt; MatrixSDK.Client.Request.account_msisdn_token(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;client_secret&quot;, country: &quot;GB&quot;, phone_number: &quot;07700900001&quot;, send_attempt: 1 }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/msisdn/requestToken&quot;, query_params: [] }With optional parameter:iex&gt; opt = %{next_link: &quot;test-site.url&quot;} iex&gt; MatrixSDK.Client.Request.account_msisdn_token(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;client_secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1, opt) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;client_secret&quot;, country: &quot;GB&quot;, phone_number: &quot;07700900001&quot;, next_link: &quot;test-site.url&quot;, send_attempt: 1 }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/msisdn/requestToken&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#account_msisdn_token/7","title":"MatrixSDK.Client.Request.account_msisdn_token/7","type":"function"},{"doc":"Returns a %Request{} struct used to unbind contact information from the user's account without deleting it from the homeserver.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.medium: the medium of the third party identifier being removed. One of: &quot;email&quot; or &quot;msisdn&quot;.address: the third party address being removed. Optional:id_server: the identity server to unbind from.Examplesiex&gt; MatrixSDK.Client.Request.account_unbind_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;email&quot;, &quot;example@example.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ medium: &quot;email&quot;, address: &quot;example@example.org&quot; }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/unbind&quot;, query_params: [] }With optional id_server parameter:iex&gt; MatrixSDK.Client.Request.account_unbind_3pid(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;email&quot;, &quot;example@example.org&quot;, %{id_server: &quot;example.org&quot;}) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ medium: &quot;email&quot;, address: &quot;example@example.org&quot;, id_server: &quot;example.org&quot; }, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/3pid/unbind&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#account_unbind_3pid/5","title":"MatrixSDK.Client.Request.account_unbind_3pid/5","type":"function"},{"doc":"Returns a %Request{} struct used to get the avatar url for a user.ArgsRequired: base_url: the base URL for the homeserver. user_id: the user ID.Examplesiex&gt; MatrixSDK.Client.Request.avatar_url(&quot;https://matrix.org&quot;, &quot;@user:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/_matrix/client/r0/profile/%40user%3Amatrix.org/avatar_url&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#avatar_url/2","title":"MatrixSDK.Client.Request.avatar_url/2","type":"function"},{"doc":"Returns a %Request{} struct used to change the password for an account on the homeserver. This request needs to be authenticated with m.login.email.identity or m.login.msisdn.identity. For more info see 3PID API flows section on the MatrixSDK.Client module.ArgsRequired:base_url: the base URL for the homeserver. new_password: the desired password for the account.auth: a map containing autentication data as defined by MatrixSDK.Client.Auth.Optional: logout_devices: true or false, whether the user's other access tokens, and their associated devices, should be revoked if the request succeeds.Examplesiex&gt; auth = MatrixSDK.Client.Auth.login_email_identity(&quot;sid&quot;, &quot;client_secret&quot;) iex&gt; MatrixSDK.Client.Request.change_password(&quot;https://matrix.org&quot;, &quot;new_password&quot;, auth) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ auth: %{ type: &quot;m.login.email.identity&quot;, threepidCreds: [%{client_secret: &quot;client_secret&quot;, sid: &quot;sid&quot;}] }, new_password: &quot;new_password&quot; }, headers: [], method: :post, path: &quot;/_matrix/client/r0/account/password&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#change_password/4","title":"MatrixSDK.Client.Request.change_password/4","type":"function"},{"doc":"Returns a %Request{} struct used to create a new room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.Optional: visibility: controls the presence of the room on the room list. One of: &quot;public&quot; or &quot;private&quot;.room_alias_name: the desired room alias local part. name: if this is included, an m.room.name event will be sent into the room to indicate the name of the room. topic: if this is included, an m.room.topic event will be sent into the room to indicate the topic for the room.invite: a list of user IDs to invite to the room.invite_3pid: a list of objects representing third party IDs to invite into the room.room_version: the room version to set for the room.creation_content: extra keys, such as m.federate, to be added to the content of the m.room.create event.initial_state: a list of state events to set in the new room.preset: convenience parameter for setting various default state events based on a preset.is_direct: boolean flag. power_level_content_override: the power level content to override in the default power level event. Examplesiex&gt; MatrixSDK.Client.Request.create_room(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/createRoom&quot;, query_params: [] }With options:iex&gt; opts = %{ ...&gt; visibility: &quot;public&quot;, ...&gt; room_alias_name: &quot;chocolate&quot;, ...&gt; topic: &quot;Some cool stuff about chocolate.&quot; ...&gt; } iex&gt; MatrixSDK.Client.Request.create_room(&quot;https://matrix.org&quot;, &quot;token&quot;, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{room_alias_name: &quot;chocolate&quot;, topic: &quot;Some cool stuff about chocolate.&quot;, visibility: &quot;public&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/createRoom&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#create_room/3","title":"MatrixSDK.Client.Request.create_room/3","type":"function"},{"doc":"Returns a %Request{} struct used to deactivate a user's account. ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.Optional: auth: a map containing autentication data as defined by MatrixSDK.Client.Auth.Examplesiex&gt; MatrixSDK.Client.Request.deactivate_account(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/account/deactivate&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#deactivate_account/3","title":"MatrixSDK.Client.Request.deactivate_account/3","type":"function"},{"doc":"Returns a %Request{} struct used to get the display name for a user.ArgsRequired: base_url: the base URL for the homeserver. user_id: the user ID.Examplesiex&gt; MatrixSDK.Client.Request.display_name(&quot;https://matrix.org&quot;, &quot;@user:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/_matrix/client/r0/profile/%40user%3Amatrix.org/displayname&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#display_name/2","title":"MatrixSDK.Client.Request.display_name/2","type":"function"},{"doc":"Returns a %Request{} struct used to forget a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.Examplesiex&gt; MatrixSDK.Client.Request.forget_room(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/forget&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#forget_room/3","title":"MatrixSDK.Client.Request.forget_room/3","type":"function"},{"doc":"Returns a %Request{} struct used by a user to join a room.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id_or_alias: the room ID or room alias.Optional: third_party_signed: a signature of an m.third_party_invite token to prove that this user owns a third party identity which has been invited to the room.Exampleiex&gt; MatrixSDK.Client.Request.join_room(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/join/%21someroom%3Amatrix.org&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#join_room/4","title":"MatrixSDK.Client.Request.join_room/4","type":"function"},{"doc":"Returns a %Request{} struct used to get a list of the user's current rooms.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.Example iex&gt; MatrixSDK.Client.Request.joined_rooms(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/joined_rooms&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#joined_rooms/2","title":"MatrixSDK.Client.Request.joined_rooms/2","type":"function"},{"doc":"Returns a %Request{} struct used to leave a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.Examplesiex&gt; MatrixSDK.Client.Request.leave_room(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/leave&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#leave_room/3","title":"MatrixSDK.Client.Request.leave_room/3","type":"function"},{"doc":"Returns a %Request{} struct used to get the homeserver's supported login types to authenticate users.ArgsRequired: base_url: the base URL for the homeserver.Examplesiex&gt; MatrixSDK.Client.Request.login(&quot;https://matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/_matrix/client/r0/login&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#login/1","title":"MatrixSDK.Client.Request.login/1","type":"function"},{"doc":"Returns a %Request{} struct used to authenticate the user and issues an access token they can use to authorize themself in subsequent requests.ArgsRequired:base_url: the base URL for the homeserver. auth: a map containing autentication data as defined by MatrixSDK.Client.Auth.Optional:device_id: ID of the client device. If this does not correspond to a known client device, a new device will be created. The server will auto-generate a device_id if this is not specified.initial_device_display_name: a display name to assign to the newly-created device.ExamplesToken authentication:iex&gt; auth = MatrixSDK.Client.Auth.login_token(&quot;token&quot;) iex&gt; MatrixSDK.Client.Request.login(&quot;https://matrix.org&quot;, auth) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{token: &quot;token&quot;, type: &quot;m.login.token&quot;}, headers: [], method: :post, path: &quot;/_matrix/client/r0/login&quot;, query_params: [] }User and password authentication with optional parameters:iex&gt; auth = MatrixSDK.Client.Auth.login_user(&quot;maurice_moss&quot;, &quot;password&quot;) iex&gt; opts = %{device_id: &quot;id&quot;, initial_device_display_name: &quot;THE INTERNET&quot;} iex&gt; MatrixSDK.Client.Request.login(&quot;https://matrix.org&quot;, auth, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ identifier: %{type: &quot;m.id.user&quot;, user: &quot;maurice_moss&quot;}, password: &quot;password&quot;, type: &quot;m.login.password&quot;, device_id: &quot;id&quot;, initial_device_display_name: &quot;THE INTERNET&quot; }, headers: [], method: :post, path: &quot;/_matrix/client/r0/login&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#login/3","title":"MatrixSDK.Client.Request.login/3","type":"function"},{"doc":"Returns a %Request{} struct used to invalidate an existing access token, so that it can no longer be used for authorization.ArgsRequired:base_url: the base URL for the homeserver.token: access token, typically obtained via the login or registration processes.Examplesiex&gt; MatrixSDK.Client.Request.logout(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/logout&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#logout/2","title":"MatrixSDK.Client.Request.logout/2","type":"function"},{"doc":"Returns a %Request{} struct used to invalidate all existing access tokens, so that they can no longer be used for authorization.ArgsRequired:base_url: the base URL for the homeserver.token: access token, typically obtained via the login or registration processes.Examplesiex&gt; MatrixSDK.Client.Request.logout_all(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/logout/all&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#logout_all/2","title":"MatrixSDK.Client.Request.logout_all/2","type":"function"},{"doc":"Returns a %Request{} struct used to request validation tokens when authenticating for change_password/4.For more info see 3PID API flows section on the MatrixSDK.Client module. ArgsRequired:base_url: the base URL for the homeserver. client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.email: the email address.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL. Examplesiex&gt; MatrixSDK.Client.Request.password_email_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;maurice@moss.yay&quot;, 1) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{client_secret: &quot;secret&quot;, email: &quot;maurice@moss.yay&quot;, send_attempt: 1}, headers: [], method: :post, path: &quot;/_matrix/client/r0/account/password/email/requestToken&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#password_email_token/5","title":"MatrixSDK.Client.Request.password_email_token/5","type":"function"},{"doc":"Returns a %Request{} struct used to request validation tokens when authenticating for change_password/4.For more info see 3PID API flows section on the MatrixSDK.Client module. ArgsRequired:base_url: the base URL for the homeserver. client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.country: the two-letter uppercase ISO-3166-1 alpha-2 country code.phone: the phone number.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL. Examplesiex&gt; MatrixSDK.Client.Request.password_msisdn_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{client_secret: &quot;secret&quot;, country: &quot;GB&quot;, phone_number: &quot;07700900001&quot;, send_attempt: 1}, headers: [], method: :post, path: &quot;/_matrix/client/r0/account/password/msisdn/requestToken&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#password_msisdn_token/6","title":"MatrixSDK.Client.Request.password_msisdn_token/6","type":"function"},{"doc":"Returns a %Request{} struct used to list the public rooms on the server with basic filtering.ArgsRequired: base_url: the base URL for the homeserver. Optional: limit: limit the number of results returned.since: a pagination token from a previous request, allowing clients to get the next (or previous) batch of rooms.server: the server to fetch the public room lists from.Examplesiex&gt; MatrixSDK.Client.Request.public_rooms(&quot;https://matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/_matrix/client/r0/publicRooms&quot;, query_params: [] }With optional parameters: iex&gt; MatrixSDK.Client.Request.public_rooms(&quot;https://matrix.org&quot;, %{limit: 10}) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/_matrix/client/r0/publicRooms&quot;, query_params: [limit: 10] }","ref":"MatrixSDK.Client.Request.html#public_rooms/2","title":"MatrixSDK.Client.Request.public_rooms/2","type":"function"},{"doc":"Returns a %Request{} struct used to list the public rooms on the server with more advanced filtering options. ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.filters: limit: limit the number of results returned.since: a pagination token from a previous request, allowing clients to get the next (or previous) batch of rooms.filter: a string to search for in the room metadata, e.g. name, topic, canonical alias, etc...include_all_networks: boolean, whether or not to include all known networks/protocols from application services on the homeserver. third_party_instance_id: the specific third party network/protocol to request from the homeserver. Can only be used if include_all_networks is false.Optional: server: the server to fetch the public room lists from.Examplesiex&gt; MatrixSDK.Client.Request.public_rooms(&quot;https://matrix.org&quot;, &quot;token&quot;, %{limit: 10}) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{limit: 10}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/publicRooms&quot;, query_params: [] }With optional parameter:iex&gt; MatrixSDK.Client.Request.public_rooms(&quot;https://matrix.org&quot;, &quot;token&quot;, %{limit: 10}, &quot;server&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{limit: 10}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/publicRooms&quot;, query_params: [server: &quot;server&quot;] }","ref":"MatrixSDK.Client.Request.html#public_rooms/4","title":"MatrixSDK.Client.Request.public_rooms/4","type":"function"},{"doc":"Returns a %Request{} struct used to redact a room event. ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID. event_id: the event ID.transaction_id: the transaction ID for this event. Clients should generate a unique ID; it will be used by the server to ensure idempotency of requests.Optional: reason: the reason for the event being redacted.Exampleiex&gt; MatrixSDK.Client.Request.redact_room_event(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;event_id&quot;, &quot;transaction_id&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :put, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/redact/event_id/transaction_id&quot;, query_params: [] }With options:iex&gt; opt = %{reason: &quot;Indecent material&quot;} iex&gt; MatrixSDK.Client.Request.redact_room_event(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;event_id&quot;, &quot;transaction_id&quot;, opt) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{reason: &quot;Indecent material&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :put, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/redact/event_id/transaction_id&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#redact_room_event/6","title":"MatrixSDK.Client.Request.redact_room_event/6","type":"function"},{"doc":"Returns a %Request{} struct used to register a guest account on the homeserver and returns an access token which can be used to authenticate subsequent requests. ArgsRequired:base_url: the base URL for the homeserver. Optional: initial_device_display_name: a display name to assign to the newly-created device.Examplesiex&gt; MatrixSDK.Client.Request.register_guest(&quot;https://matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :post, path: &quot;/_matrix/client/r0/register?kind=guest&quot;, query_params: [] } Specifiying a display name for the device: iex&gt; opts = %{initial_device_display_name: &quot;THE INTERNET&quot;} iex&gt; MatrixSDK.Client.Request.register_guest(&quot;https://matrix.org&quot;, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{initial_device_display_name: &quot;THE INTERNET&quot;}, headers: [], method: :post, path: &quot;/_matrix/client/r0/register?kind=guest&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#register_guest/2","title":"MatrixSDK.Client.Request.register_guest/2","type":"function"},{"doc":"Returns a %Request{} struct used to register a user account on the homeserver. ArgsRequired:base_url: the base URL for the homeserver. password: the desired password for the account.auth: a map containing autentication data as defined by MatrixSDK.Client.Auth. This is used to authenticate the registration request, not to define how a user will be authenticated. Optional: username: the basis for the localpart of the desired Matrix ID. If omitted, the homeserver will generate a Matrix ID local part.device_id: ID of the client device. If this does not correspond to a known client device, a new device will be created. The server will auto-generate a device_id if this is not specified.initial_device_display_name: a display name to assign to the newly-created device.inhibit_login: if true, an access_token and device_id will not be returned from this call, therefore preventing an automatic login.Examplesiex&gt; auth = MatrixSDK.Client.Auth.login_dummy() iex&gt; MatrixSDK.Client.Request.register_user(&quot;https://matrix.org&quot;, &quot;password&quot;, auth) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{auth: %{type: &quot;m.login.dummy&quot;}, password: &quot;password&quot;}, headers: [], method: :post, path: &quot;/_matrix/client/r0/register&quot;, query_params: [] }With optional parameters: iex&gt; auth = MatrixSDK.Client.Auth.login_dummy() iex&gt; opts = %{ ...&gt; username: &quot;maurice_moss&quot;, ...&gt; device_id: &quot;id&quot;, ...&gt; initial_device_display_name: &quot;THE INTERNET&quot;, ...&gt; inhibit_login: true ...&gt; } iex&gt; MatrixSDK.Client.Request.register_user(&quot;https://matrix.org&quot;, &quot;password&quot;, auth, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ auth: %{type: &quot;m.login.dummy&quot;}, device_id: &quot;id&quot;, inhibit_login: true, initial_device_display_name: &quot;THE INTERNET&quot;, password: &quot;password&quot;, username: &quot;maurice_moss&quot; }, headers: [], method: :post, path: &quot;/_matrix/client/r0/register&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#register_user/4","title":"MatrixSDK.Client.Request.register_user/4","type":"function"},{"doc":"Returns a %Request{} struct used to check the given email address is not already associated with an account on the homeserver. This should be used to get a token to register an email as part of the initial user registration.For more info see 3PID API flows section on the MatrixSDK.Client module. ArgsRequired:base_url: the base URL for the homeserver. client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.email: the email address.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL. Examplesiex&gt; MatrixSDK.Client.Request.registration_email_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;maurice@moss.yay&quot;, 1) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{client_secret: &quot;secret&quot;, email: &quot;maurice@moss.yay&quot;, send_attempt: 1}, headers: [], method: :post, path: &quot;/_matrix/client/r0/register/email/requestToken&quot;, query_params: [] }With optional parameters:iex&gt; opts = %{next_link: &quot;nextlink.url&quot;} iex&gt; MatrixSDK.Client.Request.registration_email_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;maurice@moss.yay&quot;, 1, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;secret&quot;, email: &quot;maurice@moss.yay&quot;, send_attempt: 1, next_link: &quot;nextlink.url&quot; }, headers: [], method: :post, path: &quot;/_matrix/client/r0/register/email/requestToken&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#registration_email_token/5","title":"MatrixSDK.Client.Request.registration_email_token/5","type":"function"},{"doc":"Returns a %Request{} struct used to check the given phone number is not already associated with an account on the homeserver. This should be used to get a token to register a phone number as part of the initial user registration.For more info see 3PID API flows section on the MatrixSDK.Client module. ArgsRequired:base_url: the base URL for the homeserver. client_secret: a unique string generated by the client, and used to identify the validation attempt. It must be a string consisting of the characters [0-9a-zA-Z.=_-]. Its length must not exceed 255 characters and it must not be empty.country: the two-letter uppercase ISO-3166-1 alpha-2 country code.phone: the phone number.send_attempt: stops the server from sending duplicate emails unless incremented by the client. Optional:next_link: when the validation is completed, the identity server will redirect the user to this URL. Examplesiex&gt; MatrixSDK.Client.Request.registration_msisdn_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;secret&quot;, country: &quot;GB&quot;, phone_number: &quot;07700900001&quot;, send_attempt: 1 }, headers: [], method: :post, path: &quot;/_matrix/client/r0/register/msisdn/requestToken&quot;, query_params: [] }With optional parameters:iex&gt; opts = %{next_link: &quot;nextlink.url&quot;} iex&gt; MatrixSDK.Client.Request.registration_msisdn_token(&quot;https://matrix.org&quot;, &quot;secret&quot;, &quot;GB&quot;, &quot;07700900001&quot;, 1, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{ client_secret: &quot;secret&quot;, country: &quot;GB&quot;, phone_number: &quot;07700900001&quot;, send_attempt: 1, next_link: &quot;nextlink.url&quot; }, headers: [], method: :post, path: &quot;/_matrix/client/r0/register/msisdn/requestToken&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#registration_msisdn_token/6","title":"MatrixSDK.Client.Request.registration_msisdn_token/6","type":"function"},{"doc":"Returns a %Request{} struct used to ban a user from a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.user_id: the user ID to ban from the room.Optional: reason: the reason the user has been banned.Examplesiex&gt; MatrixSDK.Client.Request.room_ban(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/ban&quot;, body: %{user_id: &quot;@user:matrix.org&quot;}, query_params: [] }With optional parameter:iex&gt; MatrixSDK.Client.Request.room_ban(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;, %{reason: &quot;Ate all the chocolate&quot;}) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/ban&quot;, body: %{user_id: &quot;@user:matrix.org&quot;, reason: &quot;Ate all the chocolate&quot;}, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_ban/5","title":"MatrixSDK.Client.Request.room_ban/5","type":"function"},{"doc":"Returns a %Request{} struct used to get a single event based on room_id and event_id.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the ID of the room the event is in. event_id: the event ID.Exampleiex&gt; MatrixSDK.Client.Request.room_event(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;$someevent&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/event/%24someevent&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_event/4","title":"MatrixSDK.Client.Request.room_event/4","type":"function"},{"doc":"Returns a %Request{} struct used to invite a user to participate in a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.user_id: the user ID to invite to the room. Examplesiex&gt; MatrixSDK.Client.Request.room_invite(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{user_id: &quot;@user:matrix.org&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/invite&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_invite/4","title":"MatrixSDK.Client.Request.room_invite/4","type":"function"},{"doc":"Returns a %Request{} struct used to get a map of MXIDs to member info objects for members of the room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.Exampleiex&gt; MatrixSDK.Client.Request.room_joined_members(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/joined_members&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_joined_members/3","title":"MatrixSDK.Client.Request.room_joined_members/3","type":"function"},{"doc":"Returns a %Request{} struct used to kick a user from a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.user_id: the user ID to kick from the room.Optional: reason: the reason the user has been kicked.Examplesiex&gt; MatrixSDK.Client.Request.room_kick(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/kick&quot;, body: %{user_id: &quot;@user:matrix.org&quot;}, query_params: [] }With optional parameter:iex&gt; MatrixSDK.Client.Request.room_kick(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;, %{reason: &quot;Ate all the chocolate&quot;}) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/kick&quot;, body: %{user_id: &quot;@user:matrix.org&quot;, reason: &quot;Ate all the chocolate&quot;}, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_kick/5","title":"MatrixSDK.Client.Request.room_kick/5","type":"function"},{"doc":"Returns a %Request{} struct used to get the list of members for this room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.Optional: at: the point in time (pagination token) to return members for in the room.membership: the kind of membership to filter for. Defaults to no filtering if unspecified.not_membership: the kind of membership to exclude from the results. Defaults to no filtering if unspecified. One of: &quot;join&quot;, &quot;invite&quot;, &quot;leave&quot;, &quot;ban&quot;.Examplesiex&gt; MatrixSDK.Client.Request.room_members(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/members&quot;, query_params: [] }With optional parameters:iex&gt; opts = %{ ...&gt; at: &quot;t123456789&quot;, ...&gt; membership: &quot;join&quot;, ...&gt; not_membership: &quot;invite&quot; ...&gt; } iex&gt; MatrixSDK.Client.Request.room_members(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/members&quot;, query_params: [at: &quot;t123456789&quot;, membership: &quot;join&quot;, not_membership: &quot;invite&quot;] }","ref":"MatrixSDK.Client.Request.html#room_members/4","title":"MatrixSDK.Client.Request.room_members/4","type":"function"},{"doc":"Returns a %Request{} struct used to get message and state events for a room. It uses pagination parameters to paginate history in the room.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID. from: the pagination token to start returning events from.dir: the direction to return events from. One of: &quot;b&quot; or &quot;f&quot;.Optional: to: the pagination token to stop returning events at.limit: the maximum number of events to return. filter: a filter to apply to the returned events. Examplesiex&gt; MatrixSDK.Client.Request.room_messages(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;t123456789&quot;, &quot;f&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/messages&quot;, query_params: [dir: &quot;f&quot;, from: &quot;t123456789&quot;] }With optional parameters:iex&gt; opts = %{ ...&gt; to: &quot;t123456789&quot;, ...&gt; limit: 10, ...&gt; filter: &quot;filter&quot; ...&gt; } iex&gt; MatrixSDK.Client.Request.room_messages(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;t123456789&quot;, &quot;f&quot;, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/messages&quot;, query_params: [dir: &quot;f&quot;, filter: &quot;filter&quot;, from: &quot;t123456789&quot;, limit: 10, to: &quot;t123456789&quot;] }","ref":"MatrixSDK.Client.Request.html#room_messages/6","title":"MatrixSDK.Client.Request.room_messages/6","type":"function"},{"doc":"Returns a %Request{} struct used to get the state events for the current state of a room.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room the events are in. Exampleiex&gt; MatrixSDK.Client.Request.room_state(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/state&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_state/3","title":"MatrixSDK.Client.Request.room_state/3","type":"function"},{"doc":"Returns a %Request{} struct used to look up the contents of a state event in a room.ArgsRequired:base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room the state event is in.event_type: the type of the state event.state_key: the key of the state to look up. Often an empty string.Exampleiex&gt; MatrixSDK.Client.Request.room_state_event(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;m.room.member&quot;, &quot;@user:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/state/m.room.member/%40user%3Amatrix.org&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_state_event/5","title":"MatrixSDK.Client.Request.room_state_event/5","type":"function"},{"doc":"Returns a %Request{} struct used to unban a user from a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.user_id: the user ID to unban from the room.Examplesiex&gt; MatrixSDK.Client.Request.room_unban(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;@user:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/unban&quot;, body: %{user_id: &quot;@user:matrix.org&quot;}, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_unban/4","title":"MatrixSDK.Client.Request.room_unban/4","type":"function"},{"doc":"Returns a %Request{} struct used to get the visibility of a given room on the server's public room directory.ArgsRequired: base_url: the base URL for the homeserver. room_id: the room ID.Exampleiex&gt; MatrixSDK.Client.Request.room_visibility(&quot;https://matrix.org&quot;, &quot;!someroom:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, method: :get, path: &quot;/_matrix/client/r0/directory/list/room/%21someroom%3Amatrix.org&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_visibility/2","title":"MatrixSDK.Client.Request.room_visibility/2","type":"function"},{"doc":"Returns a %Request{} struct used to set the visibility of a given room in the server's public room directory.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_id: the room ID.visibility: the new visibility setting for the room. One of: &quot;private&quot; or &quot;public&quot;.Exampleiex&gt; MatrixSDK.Client.Request.room_visibility(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;!someroom:matrix.org&quot;, &quot;private&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{visibility: &quot;private&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :put, path: &quot;/_matrix/client/r0/directory/list/room/%21someroom%3Amatrix.org&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#room_visibility/4","title":"MatrixSDK.Client.Request.room_visibility/4","type":"function"},{"doc":"Returns a %Request{} struct used to send a room event to a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.room_event: a state event as defined in MatrixSDK.Client.RoomEvent. Exampleiex&gt; room_event = MatrixSDK.Client.RoomEvent.message(&quot;!someroom:matrix.org&quot;, :text, &quot;Fire! Fire! Fire!&quot;, &quot;transaction_id&quot;) iex&gt; MatrixSDK.Client.Request.send_room_event(&quot;https://matrix.org&quot;, &quot;token&quot;, room_event) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{body: &quot;Fire! Fire! Fire!&quot;, msgtype: &quot;m.text&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :put, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/send/m.room.message/transaction_id&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#send_room_event/3","title":"MatrixSDK.Client.Request.send_room_event/3","type":"function"},{"doc":"Returns a %Request{} struct used to send a state event to a room.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.state_event: a state event as defined in MatrixSDK.Client.StateEvent. Exampleiex&gt; state_event = MatrixSDK.Client.StateEvent.join_rules(&quot;!someroom:matrix.org&quot;, &quot;private&quot;) iex&gt; MatrixSDK.Client.Request.send_state_event(&quot;https://matrix.org&quot;, &quot;token&quot;, state_event) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{join_rule: &quot;private&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :put, path: &quot;/_matrix/client/r0/rooms/%21someroom%3Amatrix.org/state/m.room.join_rules/&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#send_state_event/3","title":"MatrixSDK.Client.Request.send_state_event/3","type":"function"},{"doc":"Returns a %Request{} struct used to get information about the server's supported feature set and other relevant capabilities.ArgsRequired:base_url: the base URL for the homeserver.token: access token, typically obtained via the login or registration processes.Examplesiex&gt; MatrixSDK.Client.Request.server_capabilities(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/capabilities&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#server_capabilities/2","title":"MatrixSDK.Client.Request.server_capabilities/2","type":"function"},{"doc":"Returns a %Request{} struct used to get discovery information about the domain.ArgsRequired:base_url: the base URL for the homeserver. Examplesiex&gt; MatrixSDK.Client.Request.server_discovery(&quot;https://matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/.well-known/matrix/client&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#server_discovery/1","title":"MatrixSDK.Client.Request.server_discovery/1","type":"function"},{"doc":"Returns a %Request{} struct used to set the avatar url for a user.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.user_id: the user ID.avatar_url: the new avatar URL for this user.Examplesiex&gt; MatrixSDK.Client.Request.set_avatar_url(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;@user:matrix.org&quot;, &quot;mxc://matrix.org/wefh34uihSDRGhw34&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, method: :put, path: &quot;/_matrix/client/r0/profile/%40user%3Amatrix.org/avatar_url&quot;, body: %{avatar_url: &quot;mxc://matrix.org/wefh34uihSDRGhw34&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], query_params: [] }","ref":"MatrixSDK.Client.Request.html#set_avatar_url/4","title":"MatrixSDK.Client.Request.set_avatar_url/4","type":"function"},{"doc":"Returns a %Request{} struct used to set the display name for a user.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.user_id: the user ID.display_name: new display name.Examplesiex&gt; MatrixSDK.Client.Request.set_display_name(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;@user:matrix.org&quot;, &quot;mickey&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{displayname: &quot;mickey&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :put, path: &quot;/_matrix/client/r0/profile/%40user%3Amatrix.org/displayname&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#set_display_name/4","title":"MatrixSDK.Client.Request.set_display_name/4","type":"function"},{"doc":"Returns a %Request{} struct used to get the versions of the Matrix specification supported by the server.ArgsRequired:base_url: the base URL for the homeserver.Examplesiex&gt; MatrixSDK.Client.Request.spec_versions(&quot;https://matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/_matrix/client/versions&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#spec_versions/1","title":"MatrixSDK.Client.Request.spec_versions/1","type":"function"},{"doc":"Returns a %Request{} struct used to synchronises the client's state with the latest state on the server.ArgsRequired:base_url: the base URL for the homeserver. token: the authentication token returned from user login. Optional:filter: the ID of a filter created using the filter API or a filter JSON object encoded as a string.since: a point in time to continue a sync from (usuall the next_batch value from last sync).full_state: controls whether to include the full state for all rooms the user is a member of.set_presence: controls whether the client is automatically marked as online by polling this API.timeout: the maximum time to wait, in milliseconds, before returning this request.Examplesiex&gt; MatrixSDK.Client.Request.sync(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/sync&quot;, query_params: [] }With optional parameters:iex&gt; opts = %{ ...&gt; since: &quot;s123456789&quot;, ...&gt; filter: &quot;filter&quot;, ...&gt; full_state: true, ...&gt; set_presence: &quot;online&quot;, ...&gt; timeout: 1000 ...&gt; } iex&gt; MatrixSDK.Client.Request.sync(&quot;https://matrix.org&quot;, &quot;token&quot;, opts) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/sync&quot;, query_params: [ {:filter, &quot;filter&quot;}, {:full_state, true}, {:set_presence, &quot;online&quot;}, {:since, &quot;s123456789&quot;}, {:timeout, 1000} ] }","ref":"MatrixSDK.Client.Request.html#sync/3","title":"MatrixSDK.Client.Request.sync/3","type":"function"},{"doc":"Returns a %Request{} struct used to search for users.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.search_term: the term to search for.Optional: limit: limit the number of returned results.language: sets the language header for the request.Examplesiex&gt; MatrixSDK.Client.Request.user_directory_search(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;mickey&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{search_term: &quot;mickey&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/user_directory/search&quot;, query_params: [] }With limit option:iex&gt; MatrixSDK.Client.Request.user_directory_search(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;mickey&quot;, %{limit: 42}) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{search_term: &quot;mickey&quot;, limit: 42}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :post, path: &quot;/_matrix/client/r0/user_directory/search&quot;, query_params: [] }With language option:iex&gt; MatrixSDK.Client.Request.user_directory_search(&quot;https://matrix.org&quot;, &quot;token&quot;, &quot;mickey&quot;, %{language: &quot;en-US&quot;}) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{search_term: &quot;mickey&quot;}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}, {&quot;Accept-Language&quot;, &quot;en-US&quot;}], method: :post, path: &quot;/_matrix/client/r0/user_directory/search&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#user_directory_search/4","title":"MatrixSDK.Client.Request.user_directory_search/4","type":"function"},{"doc":"Returns a %Request{} struct used to get the user profile for a given user id.ArgsRequired: base_url: the base URL for the homeserver. user_id: the user ID.Examplesiex&gt; MatrixSDK.Client.Request.user_profile(&quot;https://matrix.org&quot;, &quot;@user:matrix.org&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/_matrix/client/r0/profile/%40user%3Amatrix.org&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#user_profile/2","title":"MatrixSDK.Client.Request.user_profile/2","type":"function"},{"doc":"Returns a %Request{} struct used to check if a username is available and valid for the server.ArgsRequired:base_url: the base URL for the homeserver. username: the basis for the localpart of the desired Matrix ID. Examples iex&gt; MatrixSDK.Client.Request.username_availability(&quot;https://matrix.org&quot;, &quot;maurice_moss&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [], method: :get, path: &quot;/_matrix/client/r0/register/available?username=maurice_moss&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#username_availability/2","title":"MatrixSDK.Client.Request.username_availability/2","type":"function"},{"doc":"Returns a %Request{} struct used to get information about the owner of a given access token.ArgsRequired: base_url: the base URL for the homeserver. token: access token, typically obtained via the login or registration processes.Examplesiex&gt; MatrixSDK.Client.Request.whoami(&quot;https://matrix.org&quot;, &quot;token&quot;) %MatrixSDK.Client.Request{ base_url: &quot;https://matrix.org&quot;, body: %{}, headers: [{&quot;Authorization&quot;, &quot;Bearer token&quot;}], method: :get, path: &quot;/_matrix/client/r0/account/whoami&quot;, query_params: [] }","ref":"MatrixSDK.Client.Request.html#whoami/2","title":"MatrixSDK.Client.Request.whoami/2","type":"function"},{"doc":"","ref":"MatrixSDK.Client.Request.html#t:base_url/0","title":"MatrixSDK.Client.Request.base_url/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Request.html#t:body/0","title":"MatrixSDK.Client.Request.body/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Request.html#t:headers/0","title":"MatrixSDK.Client.Request.headers/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Request.html#t:method/0","title":"MatrixSDK.Client.Request.method/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Request.html#t:path/0","title":"MatrixSDK.Client.Request.path/0","type":"type"},{"doc":"","ref":"MatrixSDK.Client.Request.html#t:t/0","title":"MatrixSDK.Client.Request.t/0","type":"type"},{"doc":"Convenience functions for building room events.","ref":"MatrixSDK.Client.RoomEvent.html","title":"MatrixSDK.Client.RoomEvent","type":"module"},{"doc":"Returns a RoomEvent struct of type m.room.message. Exampleiex&gt; MatrixSDK.Client.RoomEvent.message(&quot;!someroom:matrix.org&quot;, :text, &quot;Fire! Fire! Fire!&quot;, &quot;transaction_id&quot;) %MatrixSDK.Client.RoomEvent{ content: %{body: &quot;Fire! Fire! Fire!&quot;, msgtype: &quot;m.text&quot;}, type: &quot;m.room.message&quot;, room_id: &quot;!someroom:matrix.org&quot;, transaction_id: &quot;transaction_id&quot; }","ref":"MatrixSDK.Client.RoomEvent.html#message/4","title":"MatrixSDK.Client.RoomEvent.message/4","type":"function"},{"doc":"","ref":"MatrixSDK.Client.RoomEvent.html#t:t/0","title":"MatrixSDK.Client.RoomEvent.t/0","type":"type"},{"doc":"Convenience functions for building state events.","ref":"MatrixSDK.Client.StateEvent.html","title":"MatrixSDK.Client.StateEvent","type":"module"},{"doc":"Returns a StateEvent struct of type m.room.join_rules. ExampleMatrixSDK.Client.StateEvent.join_rules(&quot;!someroom:matrix.org&quot;. &quot;public&quot;)","ref":"MatrixSDK.Client.StateEvent.html#join_rules/2","title":"MatrixSDK.Client.StateEvent.join_rules/2","type":"function"},{"doc":"","ref":"MatrixSDK.Client.StateEvent.html#t:t/0","title":"MatrixSDK.Client.StateEvent.t/0","type":"type"},{"doc":"Matrix Elixir SDKA Matrix SDK for Elixir. It is currently in active (and early) development. The first (unstable) version has been released to hex. The docs can be found at https://hexdocs.pm/matrix_sdk. The first release provides a simple wrapper around the main endpoints of the Matrix client-server API. There are still many endpoints to be implemented; if you feel like contributing, please don't hesitate to open an issue or a PR (all skill levels welcome)!Likewise, if you want to start a project using the SDK, let me know!","ref":"readme.html","title":"Matrix Elixir SDK","type":"extras"},{"doc":"In future, the SDK plans to include:an encryption library (currently in development): olm-ex.further abstractions around the Client library to handle state.a wrapper for the Server-Server API&amp; more tbd.","ref":"readme.html#roadmap","title":"Matrix Elixir SDK - Roadmap","type":"extras"},{"doc":"The package can be installed by adding matrix_sdk to your list of dependencies in mix.exs:def deps do [ {:matrix_sdk, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"Matrix Elixir SDK - Installation","type":"extras"},{"doc":"Guest account registration. When initially joining the room it will ask you to fill out a consent form in the browser. Once this is done try joining the room again.# Set the URL for the homeserver, this is the first argument of every function in the Client. iex(1)&gt; url = &quot;https://matrix.org&quot; # Set the room, this is used for the join_room/3 call. iex(2)&gt; room = &quot;#elixirsdktest:matrix.org&quot; # ... iex(3)&gt; {:ok, %{body: %{&quot;access_token&quot; =&gt; token}}} = MatrixSDK.Client.register_guest(url) # ... iex(4)&gt; {:ok, %{body: %{&quot;consent_uri&quot; =&gt; consent_uri}}} = MatrixSDK.Client.join_room(url, token, room) # Open the link in the browser and accept the terms. iex(5)&gt; MatrixSDK.Client.join_room(url, token, room_address) # ...Username and password login with an existing account:iex(1)&gt; url = &quot;https://matrix.org&quot; # ... iex(2)&gt; auth = MatrixSDK.Client.Auth.login_user(&quot;username&quot;, &quot;supersecretpassword&quot;) %{ identifier: %{type: &quot;m.id.user&quot;, user: &quot;username&quot;}, password: &quot;supersecretpassword&quot;, type: &quot;m.login.password&quot; } iex(3)&gt; {:ok, %{body: %{&quot;access_token&quot; =&gt; token}}} = MatrixSDK.Client.login(url, auth) # ... iex(4)&gt; MatrixSDK.Client.joined_rooms(url, token) # Returns a list of the rooms joined with that account. iex(5)&gt; MatrixSDK.Client.logout(url, token) # Invalidates the token and logs the user out.","ref":"readme.html#basic-usage","title":"Matrix Elixir SDK - Basic Usage","type":"extras"}]